/*  Tutorial 21

    a - Rotating and Zooming

    by Michael Milne
*/
PROGRAM ROTZOM;
    CONST
        rzarrow = 1;    //Rotate and Zoom arrow graph no.
    GLOBAL
        rzarrowid;      //Variable to store the process id of arrow
    PRIVATE
        rzangle;        //Temporary variable to store the arrows angle for write_int
        rzsize;         //Temporary variable to store the arrows size for write_int
    BEGIN
        load_fpg("tut21.fpg");  //load tut21 fpg file
        set_mode(m640x480);     //set screen mode to 640x480

        rzarrowid = arrow();    //create an arrow process and store the id in
                                //rzarrowid so we can modify angle and size
        LOOP                    //Main loop
            write(0,0,460,0,"Tutorial 21a - Rotating and Zooming of sprites by Michael Milne");
            write(0,0,470,0,"Use L/R arrows to rotate and U/D arrows to zoom!");
            SWITCH(scan_code)   //Use switch to determine the key press (not best method - but it works)
                CASE _left:                 //If left arrow pressed...
                    rzarrowid.angle-=2000;  //...decrease angle by 2 degrees
                END
                CASE _right:                //If right arrow pressed...
                    rzarrowid.angle+=2000;  //...increase angle by 2 degrees
                END
                CASE _up:                   //If up arrow pressed...
                    rzarrowid.size+=10;     //...increase size by 10%
                END
                CASE _down:                 //If down arrow pressed...
                    rzarrowid.size-=10;     //...decrease size by 10%
                END
            END
            rzangle = rzarrowid.angle;  //temporarily store angle in rzangle
            rzsize = rzarrowid.size;    //temporarily store size in rzsize
            write(0,0,0,0,"Angle:");    //write "Angle:" on screen
            write_int(0,60,0,0,OFFSET rzangle); //write angle value to screen
            write(0,0,10,0,"Size:");    //write "Size:" on screen
            write_int(0,60,10,0,OFFSET rzsize); //write size value to screen
            FRAME;                      //frame finished
            delete_text(all_text);      //delete all text ready for next frame
        END
    END


PROCESS arrow();            //arrow process which shows the arrow on the screen
                            //by modifying the angle and size we can rotate and zoom it
                            //this can either be done in the process itself or as
                            //in this example by getting the process id when it
                            //is called and modifying the values from the main prog
    PRIVATE
    BEGIN
        x = 320;            //x coord equals 320 (middle)
        y = 240;            //y coord equals 240 (middle)
        graph = rzarrow;    //graphic id equals 1 (rzarrow const)
        LOOP
            FRAME;          //Loop to draw arrow on each frame
        END
    END